Bug 15047 - libstdc++ testing does not work remotely
Summary: libstdc++ testing does not work remotely
Status: RESOLVED WONTFIX
Alias: None
Product: gcc
Classification: Unclassified
Component: libstdc++ (show other bugs)
Version: 4.0.0
: P2 enhancement
Target Milestone: ---
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on: 10251 11610
Blocks:
  Show dependency treegraph
 
Reported: 2004-04-21 15:58 UTC by Daniel Jacobowitz
Modified: 2010-02-15 14:34 UTC (History)
2 users (show)

See Also:
Host: i386-pc-linux-gnu
Target: arm-unknown-linux-gnu
Build:
Known to work:
Known to fail:
Last reconfirmed: 2005-12-15 04:50:23


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Daniel Jacobowitz 2004-04-21 15:58:53 UTC
The libstdc++ tests do not work when run over RSH.  There are two problems:
  - the shared libstdc++ is picked up using LD_LIBRARY_PATH, which is
    only set on the host.  The shared libstdc++ doesn't even exist on the
    target.  I don't have any idea what to do about this.
  - Many of the tests read input files that they expect to be in the current
    directory.  These files are never downloaded to the remote system, so
    many tests show assertion failures.  It might be as simple as making
    sure to download all supporting files before running any tests.
Comment 1 Andrew Pinski 2004-04-21 16:01:43 UTC
PR 11610 is the bug report for copying the files over.
Comment 2 Andrew Pinski 2004-04-21 16:02:20 UTC
PR 10251 looks very much related.
Comment 3 dank 2004-04-21 16:33:01 UTC
The way I dealt with LD_LIBRARY_PATH was to
simply run the tests in a chroot environment
with the libstdc++ under test being the 
chroot environment's active libstdc++.
I'm happy with that.

The file copying stuff I never figured out;
one of these days I intended to follow up
on the comments in PR 11610 but never got a round tuit.
Comment 4 Daniel Jacobowitz 2004-04-21 16:59:54 UTC
Copying the files turned out to be easy.  I have a patch.
For the shared library, the thing to do will probably be to rely
on LD_RUN_PATH and download libstdc++ and libgcc_s to the target.
Comment 5 Andrew Pinski 2004-04-21 17:18:45 UTC
Confirmed.
Comment 6 CVS Commits 2004-04-23 14:33:40 UTC
Subject: Bug 15047

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	drow@gcc.gnu.org	2004-04-23 14:33:36

Modified files:
	libstdc++-v3   : ChangeLog 
	libstdc++-v3/testsuite/lib: libstdc++.exp 

Log message:
	PR libstdc++/15047, libstdc++/11610
	* testsuite/lib/libstdc++.exp (v3-copy-files): Use remote_download.
	(libstdc++_init): Don't pass outdir to v3-copy-files.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/ChangeLog.diff?cvsroot=gcc&r1=1.2456&r2=1.2457
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/testsuite/lib/libstdc++.exp.diff?cvsroot=gcc&r1=1.19&r2=1.20

Comment 7 CVS Commits 2004-04-23 15:39:06 UTC
Subject: Bug 15047

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	drow@gcc.gnu.org	2004-04-23 15:39:02

Modified files:
	libstdc++-v3   : ChangeLog 
	libstdc++-v3/testsuite/lib: libstdc++.exp 

Log message:
	PR libstdc++/15047, libstdc++/11610
	* testsuite/lib/libstdc++.exp (v3-copy-files): Use remote_download.
	(libstdc++_init): Don't pass outdir to v3-copy-files.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.2224.2.80&r2=1.2224.2.81
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/testsuite/lib/libstdc++.exp.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.15.4.2&r2=1.15.4.3

Comment 8 Benjamin Kosnik 2004-05-13 16:10:26 UTC
What's the remaining status on this? Is the LD_LIBRARY_PATH bit just a glob of
documentation that could be applied to:

http://gcc.gnu.org/onlinedocs/libstdc++/test.html

If so, let's do it and close out this sucker.

-benjamin
Comment 9 Daniel Jacobowitz 2004-05-13 17:40:19 UTC
Subject: Re:  libstdc++ testing does not work remotely

Right now we don't copy the shared libraries to the target.  I'd like
to figure out how to do that, and then I can document how to use
rsh or ssh to run the tests on a hosted target board.
Comment 10 Benjamin Kosnik 2004-05-13 20:35:59 UTC
Ok, since this is already an enhancement, and now it has well defined
objectives, I don't have a problem with keeping it open.

It would indeed be interesting to have this work, although not so interesting
that I am going to put any effort into it myself....

I'd imagine that newlib/libjava would also need this kind of thing, right? Can't
the required bits just be stolen from somebody who has already figured this out...

best,
-benjamin
Comment 11 Daniel Jacobowitz 2004-05-13 21:29:09 UTC
Subject: Re:  libstdc++ testing does not work remotely

Newlib doesn't support shared libraries, so it's not an issue.  Libjava
doesn't support this either (nor does gcc; the first thing to do will
be making gcc/g++ copy the shared libgcc_s.so.1 to the target).
Comment 12 Paolo Carlini 2010-02-13 23:55:34 UTC
Any progress on this? Should be really kept open after almost 6 years of inactivity? Thanks for any update.
Comment 13 joseph@codesourcery.com 2010-02-14 02:07:37 UTC
Subject: Re:  libstdc++ testing does not work remotely

Given the right board file and site.exp, installed libstdc++ testing works 
fine for both remote host and remote target (modulo one installed testing 
bug: bug 23867) and has done so for some time, but I don't know about 
build-tree testing which is what this bug report seems to be about.

Comment 14 Paolo Carlini 2010-02-14 23:15:50 UTC
Thanks Joseph. Could you possibly reach Daniel and ask him to provide a bit of feedback here? Thanks in advance.
Comment 15 Daniel Jacobowitz 2010-02-15 14:34:49 UTC
I no longer care whether this works; I don't do build-tree testing.  It's probably still broken, but with no one using it, closing as WONTFIX.